<?php

// Simple InUSE Check
if ( !defined('QF_STARTED') )
        die('Hacking attempt');

define('QF_GALLERY_FOLDER_ID', 'sys_gallery');

define('QF_GALLERY_CACHE_PREFIX', 'FOX_GALLERY.');

define('QF_GALLERY_SEARCH_ALL', 0);
define('QF_GALLERY_SEARCH_LAST10', 1);
define('QF_GALLERY_SEARCH_USERID', 2);


class QF_Gallery
{
    var $items  = Array();
    var $albums = Array();
    var $u_itms = Array();
    var $al_tid = Array();
    var $my_folder = false;

    function QF_Gallery()
    {
        global $QF;
        $QF->Run_Module('Files');

        if ($finfo = $QF->Files->Get_FolderInfo(QF_GALLERY_FOLDER_ID))
            $this->my_folder = $finfo['id'];
        else
            $this->my_folder = $QF->Files->Create_Folder(QF_GALLERY_FOLDER_ID, 0, QF_GALLERY_FOLDER_ID, false, true);

    }

    function Put_To_Album($item_id, $album_id)
    {
        global $QF;

        $album = $this->Get_Album_Info($album_id);
        $item  = $this->Get_Item_Info($item_id);

        if (!$album || !$item)
            return false;

        if (in_array($item_id, $album['items']))
            return true;

        $data = Array (
            'item_id' => $item_id,
            'album_id' => $album['id'],
            'put_by' => $QF->User->UID,
            'put_at' => $QF->Timer->time,
            );

        if ($last_itms = $QF->DBase->Do_Select_All('gal_al_itms', 'item_id', Array('album_id' => $album['id']), ' ORDER BY put_at DESC LIMIT 0, 2'))
        {
            $last_itms = array_reverse($last_itms);
            $last_itms[] = $item_id;
        }
        else
            $last_itms = Array($item_id);
        $last_itms = implode('|', $last_itms);

        if ($QF->DBase->Do_Insert('gal_al_itms', $data))
        {
            $QF->DBase->Do_Update('gal_albums', Array('lasttime' => $QF->Timer->time, 'lastthree' => $last_itms), Array('id' => $album['id']));
            $QF->Cache->Drop(QF_GALLERY_CACHE_PREFIX);
            return true;
        }
    }

    function Create_Item($caption, $file_id, $params = false)
    {
        global $QF;

        if (($finfo = $QF->Files->Get_FileInfo($file_id)) && $finfo['has_pics'])
        {
            $new_id = qf_short_hash($caption.' - '.$QF->User->uname);
            $data = Array(
                'author' => $QF->User->uname, 'author_id' => $QF->User->UID,
                'time' => $QF->Timer->time, 'r_level' => 0, 'description' => '',
                );

            if (is_array($params))
              foreach ($params as $par=>$val)
                if (isset($data[$par]) && !empty($val))
                {
                    settype($val, gettype($data[$par]));
                    $data[$par] = $val;
                }
            $data['r_level'] = min($data['r_level'], QF_FOX2_MAXULEVEL);
            $data += Array(
                'id' => $new_id, 'caption' => $caption, 'file_id' => $file_id,
                );

            if ($QF->DBase->Do_Select('gal_items', '*', Array('id' => $new_id, 'file_id' => $file_id), '', QF_SQL_WHERE_OR ))
                return false; // duplicate enrties
            if ($QF->DBase->Do_Insert('gal_items', $data))
            {
                $QF->Files->Move_File($file_id, $this->my_folder);
                $filename = $QF->LNG->Translit($caption.' by '.$QF->User->uname);
                if ($ext = pathinfo($finfo['filename'], PATHINFO_EXTENSION))
                    $filename.= '.'.$ext;

                $upd = Array(
                    'caption'  => $caption,
                    'filename' => $filename,
                    'r_level'  => $data['r_level'],
                    );
                $QF->Files->Modif_File($file_id, $upd);

                unset($this->u_itms[$data['author_id']]);
                $QF->Cache->Drop(QF_GALLERY_CACHE_PREFIX);

                return $new_id;
            }
        }

        return false;
    }

    function Create_Album($caption, $t_id = '', $owner = 0, $access = false)
    {
        global $QF;

        if (!$caption)
            return false;

        if (!preg_match('#^\w+$#D', $t_id))
            $t_id = preg_replace('#\W#', '', strtr($QF->LNG->Translit($caption), ' ', '_'));

        $t_id = strtolower($t_id);

        if ($this->Get_Album_Info($t_id))
            return false;

        $data = Array(
            't_id'     => $t_id,
            'caption'  => $caption,
            'owner_id' => abs($owner),
            'lasttime' => $QF->Timer->time,
            );

        if (!$owner)
        {
            if (isset($access['r_level']))
                $data['w_level'] = $data['r_level'] = min(abs($access['r_level']), QF_FOX2_MAXULEVEL);
            if (isset($access['w_level']))
                $data['w_level'] = min(abs($access['w_level']), $data['r_level'], QF_FOX2_MAXULEVEL);
        }

        if ($id = $QF->DBase->Do_Insert('gal_albums', $data))
        {
            $QF->Cache->Drop(QF_GALLERY_CACHE_PREFIX);
            return $id;
        }

        return false;
    }

    function Get_Items($mode = QF_GALLERY_SEARCH_ALL, $param = false, $level = false)
    {
        global $QF;

        $quer = Array();
        $flags = 0;
        $other = Array('order' => Array('time' => 'DESC'));
        switch ($mode)
        {
            case QF_GALLERY_SEARCH_LAST10:
                $other['limit'] = Array(0, 10);
                break;
            case QF_GALLERY_SEARCH_USERID:
                $quer  = Array('author_id' => $param);
                break;
        }
        if (is_int($level))
        {
            $flags |= QF_SQL_USEFUNCS;
            $quer['r_level'] = ($level >= 0) ? '<= '.$level : '>= '.abs($level);
        }

        if ($datas = $QF->DBase->Do_Select_All('gal_items', 'id', $quer, $other, $flags))
            return $datas;

        return null;
    }

    function Get_Albums($mode = QF_GALLERY_SEARCH_ALL, $param = false, $level = false)
    {
        global $QF;

        $quer = Array();
        $other = Array('order' => Array('lasttime' => 'DESC'));
        switch ($mode)
        {
            case QF_GALLERY_SEARCH_LAST10:
                $other['limit'] = Array(0, 10);
                break;
            case QF_GALLERY_SEARCH_USERID:
                $quer = Array('owner_id' => $param);
                break;
        }
        if (is_int($level))
        {
            $flags |= QF_SQL_USEFUNCS;
            $quer['r_level'] = ($level >= 0) ? '<= '.$level : '>= '.abs($level);
        }

        if ($datas = $QF->DBase->Do_Select_All('gal_albums', 'id', $quer, $other))
            return $datas;

        return null;
    }

    function Get_Album_Info($album_id)
    {
        global $QF;

        if (is_numeric($album_id))
            $datas =&$this->albums;
        elseif (preg_match('#^\w+$#D', $album_id))
        {
            $album_id = strtolower($album_id);
            $datas =&$this->al_tid;
        }
        else
            return false;


        if (isset($datas[$album_id]))
            return $datas[$album_id];

        if ($this->Load_AlbumInfos($album_id))
            return $datas[$album_id];

        return false;
    }

    function Get_Item_Info($item_id)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $item_id)) // incorrect ID
            return false;

        $item_id = strtolower($item_id);

        if (isset($this->items[$item_id]))
            return $this->items[$item_id];

        if ($this->Load_ItemInfos($item_id))
            return $this->items[$item_id];

        return false;
    }

    function Load_AlbumInfos($ids)
    {
        global $QF;

        if (!$ids)
            return false;

        if (!is_array($ids))
            $ids = explode('|', $ids);

        $ids = array_unique($ids);
        sort($ids);

        if (count($ids) > 2)
            $cachename = QF_GALLERY_CACHE_PREFIX.'AL_Qs.'.md5(implode('|', $ids));

        $alb_q = Array('gal_albums' => Array('fields' => '*', 'where' => Array('id' => $ids, 't_id' => $ids)),
                       'gal_al_itms'  => Array('fields' => Array('item_id' => 'items'), 'join' => Array('album_id' => 'id'), 'order' => Array('put_at' => 'desc')));

        if ($cachename && (list($albums, $al_tid) = $QF->Cache->Get($cachename)) && is_array($albums) && is_array($al_tid))
        {
            $this->albums += $albums;
            if (count($al_tid))
                foreach($al_tid as $t_id => $id)
                    $this->al_tid[$t_id] =& $this->albums[$id];
            return true;
        }
        elseif ($datas = $datas = $QF->DBase->Do_Multitable_Select($alb_q, '', QF_SQL_LEFTJOIN | QF_SQL_SELECTALL | QF_SQL_WHERE_OR))//$QF->DBase->Do_Select_All('gal_albums', '*', Array('id' => $ids, 't_id' => $ids), '', QF_SQL_WHERE_OR))
        {
            $ids = Array();
            $al_tid = $albums = Array();

            foreach ($datas as $data)
            {
                $id = $data['id'];
                if (!isset($albums[$id]))
                {
                    $ids[] = $id;
                    $t_id = strtolower($data['t_id']);
                    $data['items'] = ($data['items']) ? Array($data['items']) : Array();
                    $data['lastthree'] = (preg_match('#^[0-9A-z]{8}(\|[0-9A-z]{8})*$#', $data['lastthree'])) ? explode('|', $data['lastthree']) : array();
                    $albums[$id] = $data;
                    if ($t_id)
                        $al_tid[$t_id] = $id;
                }
                else
                    $albums[$id]['items'][] = $data['items'];
            }

            $this->albums += $albums;
            if (count($al_tid))
                foreach($al_tid as $t_id => $id)
                    $this->al_tid[$t_id] =& $this->albums[$id];

            if ($cachename)
                $QF->Cache->Set($cachename, Array($albums, $al_tid));
            return true;
        }
        else
            return false;
    }

    function Load_ItemInfos($ids, $with_fileinfos = false)
    {
        global $QF;

        if (!$ids)
            return false;

        if (!is_array($ids))
            $ids = explode('|', $ids);

        $ids = array_unique($ids);
        sort($ids);

        if (count($ids) > 2)
            $cachename = QF_GALLERY_CACHE_PREFIX.'ITM_Qs.'.md5(implode('|', $ids));

        if ($cachename && ($items = $QF->Cache->Get($cachename)) && is_array($items))
        {
            $this->items += $items;
            $fids = qf_2darray_cols($items, 'file_id');
            if ($with_fileinfos)
                $QF->Files->Load_FileInfos($fids);

            return true;
        }
        elseif ($datas = $QF->DBase->Do_Select_All('gal_items', '*', Array('id' => $ids)))
        {
            $ids = Array();
            $fids = Array();
            $items = Array();

            foreach ($datas as $data)
            {
                $ids[] = $id = $data['id'];
                $fids[] = $data['file_id'];
                $data['albums'] = Array();
                $items[$id] = $data;
            }

            if ($with_fileinfos)
                $QF->Files->Load_FileInfos($fids);

            $mt_q = Array('gal_al_itms' => Array('fields' => 'item_id', 'where' => Array('item_id' => $ids)),
                          'gal_albums'  => Array('fields' => Array('id', 't_id', 'caption', 'r_level'), 'join' => Array('id' => 'album_id')));
            if ($datas = $QF->DBase->Do_Multitable_Select($mt_q, '', QF_SQL_LEFTJOIN | QF_SQL_SELECTALL))
            {
                foreach ($datas as $data)
                {
                    $id = $data['item_id'];
                    unset($data['item_id']);
                    $items[$id]['albums'][$data['id']] = $data;
                }
            }

            $this->items += $items;

            if ($cachename)
                $QF->Cache->Set($cachename, $items);
            return true;
        }
        else
            return false;
    }

}

?>